package new_mobile_api_controllers

import (
	"XT_New/controllers/mobile_api_controllers"
	"XT_New/enums"
	"XT_New/service"
	"XT_New/utils"
	"fmt"
	"time"
)

type NewCommonApiController struct {
	mobile_api_controllers.MobileBaseAPIAuthController
}

func (this *NewCommonApiController) GetTotalDialysis() {
	timeLayout := "2006-01-02"
	loc, _ := time.LoadLocation("Local")
	startime := this.GetString("startime")
	fmt.Println("开始时间", startime)
	endtime := this.GetString("endtime")
	fmt.Println("结束时间", endtime)
	startTimes, _ := time.ParseInLocation(timeLayout+" 15:04:05", startime+" 00:00:00", loc)
	startimes := startTimes.Unix()
	fmt.Println("startime", startimes)
	endtimes, _ := time.ParseInLocation(timeLayout+" 15:04:05", endtime+" 00:00:00", loc)
	endtimeData := endtimes.Unix()
	fmt.Println("结束日期", endtimeData)
	adminUser := this.GetMobileAdminUserInfo()
	orgid := adminUser.Org.Id
	fmt.Println("机构ID", orgid)
	//统计透析总量
	_, total, _ := service.GetDialysiTotal(startimes, endtimeData, orgid)

	modeType, err := service.GetDialysisCountMode(startimes, endtimeData, orgid)
	if err != nil {
		this.ServeFailJSONWithSGJErrorCode(enums.ErrorCodeSystemError)
		return
	}
	this.ServeSuccessJSON(map[string]interface{}{
		"total":    total,
		"modetype": modeType,
	})
}

func (this *NewCommonApiController) GetMobileTotalLapseCount() {
	startime, _ := this.GetInt64("startime")
	fmt.Println("startime", startime)
	endtime, _ := this.GetInt64("endtime")
	fmt.Println("endtime", endtime)
	adminUser := this.GetMobileAdminUserInfo()
	orgid := adminUser.Org.Id
	_, total, err := service.GetTotalRollOutPatients(orgid)
	count := service.GetPatientTotalCount(orgid)
	if err != nil {
		this.ServeFailJSONWithSGJErrorCode(enums.ErrorCodeSystemError)
		return
	}
	this.ServeSuccessJSON(map[string]interface{}{
		"total": total,
		"count": count,
	})
}

func (this *NewCommonApiController) GetMobileTotalSexCount() {
	startime, _ := this.GetInt64("startime")
	fmt.Println("startime", startime)
	endtime, _ := this.GetInt64("endtime")
	fmt.Println("endtime", endtime)
	adminUser := this.GetMobileAdminUserInfo()
	orgid := adminUser.Org.Id
	total := service.GetPatientTotalCount(orgid)
	_, totalSex, err := service.GetManPatientTotal(orgid)
	if err != nil {
		this.ServeFailJSONWithSGJErrorCode(enums.ErrorCodeSystemError)
		return
	}
	this.ServeSuccessJSON(map[string]interface{}{
		"total":    total,
		"totalSex": totalSex,
	})
}

func (this *NewCommonApiController) GetMobileTotalInfectiousCout() {
	startime, _ := this.GetInt64("startime")
	fmt.Println("startime", startime)
	endtime, _ := this.GetInt64("endtime")
	fmt.Println("endtime", endtime)
	adminUser := this.GetMobileAdminUserInfo()
	orgid := adminUser.Org.Id
	//统计透析总人数
	total := service.GetPatientTotalCount(orgid)
	//统计透析人数传染病所占比例
	count, err := service.GetPatientInfectiousCount(orgid)
	//统计其他
	_, otherTotal, err := service.GetPatientOtherInfectious(orgid)
	if err != nil {
		this.ServeFailJSONWithSGJErrorCode(enums.ErrorCodeSystemError)
		return
	}
	this.ServeSuccessJSON(map[string]interface{}{
		"total":      total,
		"count":      count,
		"otherTotal": otherTotal,
	})
}

func (this *NewCommonApiController) GetMobileTotalAgeCount() {
	startime, _ := this.GetInt64("startime")
	fmt.Println("开始时间", startime)
	endtime, _ := this.GetInt64("endtime")
	fmt.Println("结束时间", endtime)
	adminUser := this.GetMobileAdminUserInfo()
	orgid := adminUser.Org.Id
	total := service.GetPatientTotalCount(orgid)
	agecount, err := service.GetTotalAgeCount(orgid)
	//two, err := service.GetTotalAgeCountTwo(orgid, startime, endtime)
	if err != nil {
		this.ServeFailJSONWithSGJErrorCode(enums.ErrorCodeSystemError)
		return
	}
	this.ServeSuccessJSON(map[string]interface{}{
		"total":    total,
		"ageCount": agecount,
	})
}

func (this *NewCommonApiController) GetMobileTotalDialysisCount() {
	startime, _ := this.GetInt64("startime")
	fmt.Println("开始时间", startime)
	endtime, _ := this.GetInt64("endtime")
	fmt.Println("结束时间", endtime)
	adminUser := this.GetMobileAdminUserInfo()
	orgid := adminUser.Org.Id
	recordDateStr := time.Now().Format("2006-01-02")
	recordDate, parseDateErr := utils.ParseTimeStringToTime("2006-01-02", recordDateStr)
	fmt.Println(parseDateErr)
	nowtime := recordDate.Unix()
	//统计透析总人数
	total := service.GetPatientTotalCount(orgid)
	fmt.Println("total", total)
	//获取该机构下的所有病人数据
	patients, err := service.GetTotalDialysisAgeCount(orgid)
	if err != nil {
		this.ServeFailJSONWithSGJErrorCode(enums.ErrorCodeSystemError)
		return
	}
	this.ServeSuccessJSON(map[string]interface{}{
		"total":    total,
		"patients": patients,
		"nowtime":  nowtime,
	})
}

func (this *NewCommonApiController) GetMobilePatientList() {
	adminUser := this.GetMobileAdminUserInfo()
	orgid := adminUser.Org.Id
	patients, err := service.GetCurentOrgPatients(orgid)
	if err != nil {
		this.ServeFailJSONWithSGJErrorCode(enums.ErrorCodeSystemError)
		return
	}
	this.ServeSuccessJSON(map[string]interface{}{
		"patients": patients,
	})
}

func (this *NewCommonApiController) GetPrescriptionlist() {

	startime := this.GetString("startime")
	fmt.Println("startime", startime)
	endtime := this.GetString("endtime")
	fmt.Println("enditme", endtime)

	startDate, parseDateErr := utils.ParseTimeStringToTime("2006-01-02", startime)
	fmt.Println("parseDateErr", parseDateErr)
	statime := startDate.Unix()
	fmt.Println("开始时间", statime)
	endDate, _ := utils.ParseTimeStringToTime("2006-01-02", endtime)

	entime := endDate.Unix()
	fmt.Println("开始时间", statime)
	page, _ := this.GetInt64("page")
	fmt.Println("page", page)
	limit, _ := this.GetInt64("limit")
	fmt.Println("limit", limit)
	adminInfo := this.GetMobileAdminUserInfo()
	orgId := adminInfo.Org.Id
	prescriptionList, _ := service.GetAllDialysisList(statime, entime, orgId)
	list, totallist, err := service.GetDialysisPatientList(statime, entime, page, limit, orgId)
	fmt.Println("err--------------------", err)
	if err != nil {
		this.ServeFailJSONWithSGJErrorCode(enums.ErrorCodeSystemError)
		return
	}
	this.ServeSuccessJSON(map[string]interface{}{
		"list":             list,
		"totallist":        totallist,
		"prescriptionList": prescriptionList,
	})
}

func (this *NewCommonApiController) GetMobilePatientDetail() {
	adminUser := this.GetMobileAdminUserInfo()
	orgId := adminUser.Org.Id
	id, _ := this.GetInt64("id")
	fmt.Println("id", id)
	startime := this.GetString("startime")
	fmt.Println(startime)
	endtime := this.GetString("endtime")
	startDate, parseDateErr := utils.ParseTimeStringToTime("2006-01-02", startime)
	fmt.Println("parseDateErr", parseDateErr)
	statime := startDate.Unix()
	fmt.Println("开始时间", statime)
	endDate, _ := utils.ParseTimeStringToTime("2006-01-02", endtime)

	entime := endDate.Unix()
	fmt.Println("开始时间", statime)
	fmt.Println(endtime)
	limit, _ := this.GetInt64("limit")
	fmt.Println("limit", limit)
	page, _ := this.GetInt64("page")
	fmt.Println("page", page)
	patients, total, err := service.GetDialysisDetailById(id, orgId, statime, entime, limit, page)
	if err != nil {
		this.ServeFailJSONWithSGJErrorCode(enums.ErrorCodeSystemError)
		return
	}
	this.ServeSuccessJSON(map[string]interface{}{
		"patients": patients,
		"total":    total,
	})
}

func (this *NewCommonApiController) ToSearchPatient() {
	adminUser := this.GetMobileAdminUserInfo()
	orgId := adminUser.Org.Id
	keyword := this.GetString("keyword")
	startime := this.GetString("startime")
	fmt.Println(startime)
	endtime := this.GetString("endtime")
	startDate, parseDateErr := utils.ParseTimeStringToTime("2006-01-02", startime)
	fmt.Println("parseDateErr", parseDateErr)
	statime := startDate.Unix()
	fmt.Println("开始时间", statime)
	endDate, _ := utils.ParseTimeStringToTime("2006-01-02", endtime)

	entime := endDate.Unix()
	fmt.Println("开始时间", statime)
	fmt.Println(endtime)
	limit, _ := this.GetInt64("limit")
	fmt.Println("limit", limit)
	page, _ := this.GetInt64("page")
	fmt.Println("page", page)
	patient, total, err := service.GetPrescritionByName(orgId, keyword, statime, entime, limit, page)
	if err != nil {
		this.ServeFailJSONWithSGJErrorCode(enums.ErrorCodeSystemError)
		return
	}
	this.ServeSuccessJSON(map[string]interface{}{
		"patient": patient,
		"total":   total,
	})
}

func (this *NewCommonApiController) GetAllPatientsMode() {
	adminUser := this.GetMobileAdminUserInfo()
	orgId := adminUser.Org.Id
	startime := this.GetString("startime")
	fmt.Println(startime)
	endtime := this.GetString("endtime")
	startDate, parseDateErr := utils.ParseTimeStringToTime("2006-01-02", startime)
	fmt.Println("parseDateErr", parseDateErr)
	statime := startDate.Unix()
	fmt.Println("开始时间", statime)
	endDate, _ := utils.ParseTimeStringToTime("2006-01-02", endtime)
	entime := endDate.Unix()
	fmt.Println("结束日期", entime)
	value, _ := this.GetInt64("value")
	fmt.Println("value", value)
	limit, _ := this.GetInt64("limit")
	fmt.Println("limit", limit)
	page, _ := this.GetInt64("page")
	fmt.Println("page", page)
	modeId, _ := this.GetInt64("mode_id")
	fmt.Println("modeId", modeId)
	statistics, ttd, total, err := service.GetStatistics(orgId, statime, entime, value, limit, page, modeId)
	if err != nil {
		this.ServeFailJSONWithSGJErrorCode(enums.ErrorCodeSystemError)
		return
	}
	this.ServeSuccessJSON(map[string]interface{}{
		"statistics": statistics,
		"ttd":        ttd,
		"total":      total,
	})
}

func (this *NewCommonApiController) GetMobileInspectionList() {
	adminUser := this.GetMobileAdminUserInfo()
	orgid := adminUser.Org.Id
	startime := this.GetString("startime")
	fmt.Println(startime)
	endtime := this.GetString("endtime")
	startDate, parseDateErr := utils.ParseTimeStringToTime("2006-01-02", startime)
	fmt.Println("parseDateErr", parseDateErr)
	statime := startDate.Unix()
	fmt.Println("开始时间", statime)
	endDate, _ := utils.ParseTimeStringToTime("2006-01-02", endtime)
	entime := endDate.Unix()
	fmt.Println("结束日期", entime)
	references, err := service.GetInspectionTotalCount(orgid)
	if err != nil {
		this.ServeFailJSONWithSGJErrorCode(enums.ErrorCodeSystemError)
		return
	}

	counts, err := service.GetInspectionProjectCount(orgid, statime, entime)

	this.ServeSuccessJSON(map[string]interface{}{
		"Inspection": references,
		"counts":     counts,
	})
}

func (this *NewCommonApiController) GetPatientInspectionDetail() {
	adminUser := this.GetMobileAdminUserInfo()
	orgId := adminUser.Org.Id
	id, _ := this.GetInt64("id")
	fmt.Println("id", id)
	startime := this.GetString("startime")
	endtime := this.GetString("endtime")
	startDate, parseDateErr := utils.ParseTimeStringToTime("2006-01-02", startime)
	fmt.Println("parseDateErr", parseDateErr)
	statime := startDate.Unix()
	fmt.Println("开始时间", statime)
	endDate, _ := utils.ParseTimeStringToTime("2006-01-02", endtime)
	entime := endDate.Unix()
	fmt.Println("结束日期", entime)
	patientdetail, err := service.GetInspectionDetailById(id, orgId, statime, entime)
	if err != nil {
		this.ServeFailJSONWithSGJErrorCode(enums.ErrorCodeSystemError)
		return
	}
	this.ServeSuccessJSON(map[string]interface{}{
		"patientdetail": patientdetail,
	})
}

func (this *NewCommonApiController) GetSeachPatientDetail() {
	adminUser := this.GetMobileAdminUserInfo()
	orgId := adminUser.Org.Id
	keyword := this.GetString("keyword")
	fmt.Println("keyword", keyword)
	startime := this.GetString("startime")
	endtime := this.GetString("endtime")
	startDate, parseDateErr := utils.ParseTimeStringToTime("2006-01-02", startime)
	fmt.Println("parseDateErr", parseDateErr)
	statime := startDate.Unix()
	fmt.Println("开始时间", statime)
	endDate, _ := utils.ParseTimeStringToTime("2006-01-02", endtime)
	entime := endDate.Unix()
	fmt.Println("结束日期", entime)
	PatientsInfo, err := service.GetSearchPatientInfo(orgId, keyword, statime, entime)
	if err != nil {
		this.ServeFailJSONWithSGJErrorCode(enums.ErrorCodeSystemError)
		return
	}
	this.ServeSuccessJSON(map[string]interface{}{
		"PatientsInfo": PatientsInfo,
	})
}

func (this *NewCommonApiController) GetMobileNormdata() {

	adminInfo := this.GetMobileAdminUserInfo()
	orgid := adminInfo.Org.Id
	//获取系统数据
	normdata, err := service.GetNormDataByOrgId(orgid)
	if len(normdata) == 0 {
		normdata, err := service.GetNormData(0)
		if err != nil {
			this.ServeFailJSONWithSGJErrorCode(enums.ErrorCodeSystemError)
			return
		}
		this.ServeSuccessJSON(map[string]interface{}{
			"normdata": normdata,
		})
	}
	if err != nil {
		this.ServeFailJSONWithSGJErrorCode(enums.ErrorCodeSystemError)
		return
	}
	this.ServeSuccessJSON(map[string]interface{}{
		"normdata": normdata,
	})
}

func (this *NewCommonApiController) GetMobileProjectlsit() {

	adminInfo := this.GetMobileAdminUserInfo()
	orgid := adminInfo.Org.Id
	fmt.Println("orgid", orgid)
	lapseto, _ := this.GetInt64("lapseto")
	fmt.Println("专柜", lapseto)
	itemtype, _ := this.GetInt64("itemtype")
	fmt.Println("itemtype", itemtype)
	modetype, _ := this.GetInt64("modeltype")
	fmt.Println(modetype)

	firstQuarterStart := this.GetString("first_quarter_start")
	firstQuarterStartStr, _ := utils.ParseTimeStringToTime("2006-01-02", firstQuarterStart)
	firstQuarterStartUnix := firstQuarterStartStr.Unix()
	fmt.Println("第一季度开始时间", firstQuarterStartUnix)
	fisrtQuarterEnd := this.GetString("first_qurter_end")
	fisrtQuarterEndStr := fisrtQuarterEnd + " 23:59:59"
	fisrtQuarterEnds, _ := utils.ParseTimeStringToTime("2006-01-02 15:04:05", fisrtQuarterEndStr)
	fisrtQuarterEndStrUnix := fisrtQuarterEnds.Unix()
	fmt.Println("第一季度结束时间", fisrtQuarterEndStrUnix)

	secondeQuarterStart := this.GetString("second_qurter_start")
	secondeQuarterStartStr, _ := utils.ParseTimeStringToTime("2006-01-02", secondeQuarterStart)
	secondeQuarterStartUnix := secondeQuarterStartStr.Unix()
	fmt.Println("第二季度开始时间", secondeQuarterStartUnix)
	secondQuarterEnd := this.GetString("second_qurter_end")
	secondQuarterEndStr := secondQuarterEnd + " 23:59:59"
	secondQuarterEnds, _ := utils.ParseTimeStringToTime("2006-01-02 15:04:05", secondQuarterEndStr)
	secondQuarterEndStrUnix := secondQuarterEnds.Unix()
	fmt.Println("第二季度结束时间", secondQuarterEndStrUnix)

	threeQuarterStart := this.GetString("three_qurter_start")
	threeQuarterStartStr, _ := utils.ParseTimeStringToTime("2006-01-02", threeQuarterStart)
	threeQuarterStartUnix := threeQuarterStartStr.Unix()
	fmt.Println("第三季度开始时间", threeQuarterStartUnix)
	threeQuarterEnd := this.GetString("three_qurter_end")
	threeQuarterEndStr := threeQuarterEnd + " 23:59:59"
	threeQuarterEnds, _ := utils.ParseTimeStringToTime("2006-01-02 15:04:05", threeQuarterEndStr)
	threeQuarterEndStrUnix := threeQuarterEnds.Unix()
	fmt.Println("第三季度结束时间", threeQuarterEndStrUnix)

	fourQuarterStart := this.GetString("four_qurter_start")
	fourQuarterStartStr, _ := utils.ParseTimeStringToTime("2006-01-02", fourQuarterStart)
	fourQuarterStartUnix := fourQuarterStartStr.Unix()
	fmt.Println("第四季度开始时间", fourQuarterStartUnix)
	fourQuarterEnd := this.GetString("four_qurter_end")
	fourQuarterEndStr := fourQuarterEnd + " 23:59:59"
	fourQuarterEnds, _ := utils.ParseTimeStringToTime("2006-01-02 15:04:05", fourQuarterEndStr)
	fourQuarterEndStrUnix := fourQuarterEnds.Unix()
	fmt.Println("第四季度结束时间", fourQuarterEndStrUnix)

	//按季度统计
	if itemtype == 1 {
		//统计总共
		list, err := service.GetProjectList(orgid, lapseto, modetype, firstQuarterStartUnix, fourQuarterEndStrUnix, firstQuarterStartUnix, fisrtQuarterEndStrUnix, secondeQuarterStartUnix, secondQuarterEndStrUnix, threeQuarterStartUnix, threeQuarterEndStrUnix, fourQuarterStartUnix, fourQuarterEndStrUnix)
		//统计达标个数
		standList, err := service.GetProjectStandList(orgid, lapseto, modetype, firstQuarterStartUnix, fourQuarterEndStrUnix, firstQuarterStartUnix, fisrtQuarterEndStrUnix, secondeQuarterStartUnix, secondQuarterEndStrUnix, threeQuarterStartUnix, threeQuarterEndStrUnix, fourQuarterStartUnix, fourQuarterEndStrUnix)
		if err != nil {
			this.ServeFailJSONWithSGJErrorCode(enums.ErrorCodeSystemError)
			return
		}

		this.ServeSuccessJSON(map[string]interface{}{
			"list":      list,
			"standList": standList,
		})
	}
}

func (this *NewCommonApiController) GetMobileFirstQuarter() {

	adminUser := this.GetMobileAdminUserInfo()
	orgid := adminUser.Org.Id
	lapseto, _ := this.GetInt64("lapseto")
	fmt.Println("转归", lapseto)
	startime := this.GetString("startime")
	fmt.Println("startime", startime)
	startDate, parseDateErr := utils.ParseTimeStringToTime("2006-01-02", startime)
	fmt.Println("parseDateErr", parseDateErr)
	statime := startDate.Unix()
	fmt.Println("开始时间", statime)
	endtime := this.GetString("endtime")
	fmt.Println("endtime", endtime)
	endTimeYMDHmsStr := endtime + " 23:59:59"
	endDate, _ := utils.ParseTimeStringToTime("2006-01-02 15:04:05", endTimeYMDHmsStr)
	entime := endDate.Unix()
	fmt.Println("结束日期", entime)
	//group, parseDateErr := service.GetItemNameGroup(orgid, statime, entime)
	//quarter, err := service.GetFirstQuarter(orgid, statime, entime)
	count, err := service.GetQuarterTotalCount(orgid, statime, entime, lapseto)
	if err != nil {
		this.ServeFailJSONWithSGJErrorCode(enums.ErrorCodeSystemError)
		return
	}
	this.ServeSuccessJSON(map[string]interface{}{
		"count": count,
	})
}
